\chapter{Collections And Comprehension}\label{comprehension-collection}

{\LARGE C}omprehension is a method which lets one create newer collection from older ones.
In this chapter we would see how different collections can be made from existing collections.
\index{Comprehensions}

\begin{section}{Using Anonymous Argument}

\begin{subsection}{List}
The general form for list and arrays can be written ( as from chapter 2 ):
\begin{lstlisting}[style=zmbStyle]
def map(item) {/* does some magic */}
def comprehension(function, items){
   c = collection()
   for ( item : items ){
     c_m = function(c)
     c.add( c_m ) 
   }
   return c
}
// finally : 
comprehension(map, items)
//or this way :
c = collection( items ) as { map($.o) } 
\end{lstlisting}
Obviously $list()$ generates $list$ and $list.array()$ generates $array$.
Any collection structure can be used as a collector : \emph{ list, set, oset, sset, dict, sdict, odict, mset }.
\index{Comprehensions : list() }
Hence, these are valid :
\begin{lstlisting}[style=zmbStyle]
ln = list(1,2,3,4) as { $.o ** 2 } // [1,4,9,16 ]
\end{lstlisting}

So, the result of the anonymous block is taken as a function to map the item into a newer item, 
and finally added to the final collection.

One can use standard function also in case of anonymous function :

\begin{lstlisting}[style=zmbStyle]
def square( inx, itm, partial, context ){
   itm ** 2 
}
ln = list(1,2,3,4) as square // same !
ln = list(1,2,3,4) as def(inx,itm) { itm ** 2 } // same!
\end{lstlisting}


\end{subsection}

\begin{subsection}{Set}
\index{Comprehensions : set()}

Set also follows the same behavioural pattern just like $list()$, but one needs 
to remember that the $set$ collection does not allow duplicates. Thus:

\begin{lstlisting}[style=zmbStyle]
s = set( 1,2,3,4,5 ) as { $.o % 3 } // [0,1,2]
\end{lstlisting}

Basically, the $map$ function for the $set$ construct, defines the key for the item.
Thus, unlike its cousins $list()$ and $array()$, the $set()$ function may return a collection
with size less than the input collection. 

\end{subsection}

\begin{subsection}{Dict}
\index{Comprehensions : dict()}

Dictionaries are special kind of a collection with $(key,value)$ pair with unique keys.
Thus, creating a dictionary would mean uniquely specifying the key, value pair.
That can be specified either in a dictionary tuple way, or simply a pair way: 

\begin{lstlisting}[style=zmbStyle]
// range can be passed in for collection
d = dict([0:4]) as { t = { $.o : $.o **2 }  }
/* d = {0 : 0, 1 : 1, 2 : 4, 3:9 }  */
d = dict([0:4]) as { [ $.o , $.o **2 ]  }  // same as previous
\end{lstlisting}

There is another way of creating a dictionary, that is, 
passing two collections of same size, and making first collection 
as keys, mapping it to the corresponding second collection as values:

\begin{lstlisting}[style=zmbStyle]
k = ['a','b','c' ]
v = [1,2,3]
d = dict(k,v)
/*  d = { 'a' : 1 , 'b' : 2, 'c' : 3 }  */ 
\end{lstlisting}

This is formally the operation called \href{https://en.wikipedia.org/wiki/Pairing}{pairing}:
$$
D : (K,V) \to T \; ; \; t_i = ( k_i, v_i ) \; ; \; k_i \in K \; ; \; v_i \in V 
$$

\end{subsection}

\begin{subsection}{Multi Set, Group }
\index{Comprehensions : mset(), group()}
We got introduced to \emph{mset()} sometimes back. One can think it is as a frequency counter for elements 
of a collection. But that is not what it does. \emph{mset()} can also group items under a key, as demonstrated :

\begin{lstlisting}[style=zmbStyle]
l = [0:10].list() // generate a list from this range 
ms = mset( l ) as {  2 /? $.o } // group them under "even" and "odd"
// {false=[1, 3, 5, 7, 9], true=[0, 2, 4, 6, 8]} // HashMap 
\end{lstlisting}
In essence, what it did is to `group' the collections under multiple groups, all items
in the same group must have same key. 

A related problem is to run another function with the collection of each group.
This is done by the \emph{group()} function. For examples:

\begin{lstlisting}[style=zmbStyle]
l = [0:10].list() // generate a list from this range 
// group them under "even" and "odd",  
//and then count the list of items in each group,
// making it the value under the key 
g = group( l ) as {  2 /? $.o }  as {  size($.value) }  
// results in :  {false=5, true=5} // HashMap
\end{lstlisting}

A \emph{continue} inside the \emph{group()} will remove the key from the final group, as follows:

\begin{lstlisting}[style=zmbStyle]
l = list ( [0:100]) as { { "id" : random(100000) , "v" : random(100) }  }   
// filter all items where id is mapped to more than 3 elements 
g = group( l ) as {  $.id }  as { 
    sz = size($.value) 
    continue( sz > 3 )  
    $.value } 
\end{lstlisting}
This lets one filter on the result of the grouping.

Another interesting operator is \emph{*} for the dictionaries. Imagine the dictionary 
can be considered as a vector with key being the components. Thus we can come up with a rudimentary
group operation such that $ d_1 * d_2 $ defines as taking dot product of the keys ( intersection of the keys)
while the value would be simply a pair of values from $d_1, d_2$ as follows:

$$
r_{ij} = \{  k \to ( d_i[k], d_j[k] )  \}
$$

Thus the sample is as follows:

\begin{lstlisting}[style=zmbStyle]
a = { "a" : 10, "b" : 20 , "d" : 100 }
b = {  "b" : 30 , "c" : 40 }
r_ab = a * b // dict { "b" : [20,30] }
r_ba = b * a // dict { "b" : [30,20] }
\end{lstlisting}

What sort of Map we can use for \emph{mset} and \emph{group} ? 
We can use ordered map or a sorted map too. This can be easily specified as follows:

\begin{lstlisting}[style=zmbStyle]
l = [1,2,3,4,5,6]
mso = mset(col=l,order=true) // ordered map 
mss = mset(col=l,sorted=true) // sorted map 
// or even 
ms = mset(col=l, acc=sdict() ) // pass the accumulator 
\end{lstlisting}

This way, we can reuse collector accumulator from any previous steps.

\end{subsection}

\begin{subsection}{Stack And Queue }
Collection \emph{list()} can be used as both Stack and the Queue.
This is because the \emph{ZList} wrapper which wraps around any JVM list
actually implements Java \href{https://docs.oracle.com/en/java/javase/21/docs/api/java.base/java/util/Deque.html}{Deque} .

For example :

\begin{lstlisting}[style=zmbStyle]
// use as queue 
q = list()
for ( x : [0:10] ) {  q.add(x) } // enqueue 
q.remove() // we get back 0 
// use as stack 
s = list()
for ( x : [0:10] ) {  s.push(x) } // push to stack 
s.pop() // we get back 10  
\end{lstlisting}

You can read more about how \emph{Deque} can act as both.

\end{subsection}


\begin{subsection}{JVM Arrays}
Collection \emph{collection.array(type)} can be used to create arrays:
For example :

\begin{lstlisting}[style=zmbStyle]
x = [0,1,2,3]
//@[ 0,1,2,3 ] // ZArray
x.array('int')
//0,1,2,3 // int[]
//x.array('double')
//0.0,1.0,2.0,3.0 // double[]
x.array('float')
//0.0,1.0,2.0,3.0 // float[]
x.array('long')
//0,1,2,3 // long[]
x = [true, false]
//@[ true,false ] // ZArray
x.array('bool')
//true,false // boolean[]
\end{lstlisting}

\end{subsection}


\end{section}


\begin{section}{Constructs Altering the Iteration Flow}
In normal iterative languages, there are \emph{continue} and \emph{break}.
The ideas are borrowed from them, and improved to give a declarative feel onto it.

\begin{subsection}{Continue and Break}
\index{Flow Control : continue, break }

The idea of continue would be as follows :
\begin{lstlisting}[style=zmbStyle]
for ( i : items ){
   if ( condition(i) ){
      // execute some code  
      continue 
   }
   // do something else 
}
\end{lstlisting}
That is, when the condition is true, execute the code block, 
and then continue without going down further ( not going to do something else ). 
The idea of the break is :
\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=zmbStyle]
for ( i : items ){
    if ( condition(i) ){ 
    /* execute some code */  
    break 
    }
    // do something else here
}
\end{lstlisting}
\end{minipage}\end{center}

That is, when the condition is true, execute the code block, 
and then break without proceeding with the loop further. 
Evidently they change the flow of control of the iterations.
\end{subsection}

\begin{subsection}{Continue}
\index{Flow Control : continue}
As we can see, the $condition()$ is implicit in both $break$ and $continue$,
in ZoomBA this has become explicit. Observe that:

\begin{lstlisting}[style=zmbStyle]
for ( i : items ){
    continue( condition(i) ){ /* continue after executing this */} 
    // do something else 
}
\end{lstlisting}
is equivalent of what was being shown in the previous subsection.
As a practical example, lets have some fun with the problem of $FizzBuzz$,
that is, given a list of integers, if $n$ is divisible by $3$ print $Fizz$,
if something is divisible by $5$, print $Buzz$, and for anything else print the number $n$. 
A solution is :

\begin{lstlisting}[style=zmbStyle]
for ( n : integers ){ // note that "x /? y" implies x divides y ?
    continue( n /? 15 ){ println('FizzBuzz') } 
    continue( n /? 3  ){ println('Fizz') }
    continue( n /? 5  ){ println('Buzz') }
    println(n) 
}
\end{lstlisting}
Obviously, the block of the continue is optional.
Thus, one can freely code the way it was mentioned in the 
earlier subsection.
\end{subsection}


\begin{subsection}{Break}
\index{Flow Control : break}
As mentioned in the previous subsection, 
$break$ also has the same features as continue. 

\begin{lstlisting}[style=zmbStyle]
for ( i : items ){
    break( condition(i) ){ /* break loop after executing this */} 
    // do something else 
}
\end{lstlisting}
is equivalent of what was being shown in the previous subsection.
As a practical example, lets find if two elements of two lists
when added together generates a given value or not.
Formally :

$$
\exists (a,b) \in A \times B \; ; \; s.t. \; a + b = c  
$$

\begin{lstlisting}[style=zmbStyle]
A = [ 1, 4, 10, 3, 8 ]
B = [ 2, 11, 6 , 9 ]
c = 10 
for ( p : A*B  ){
    break( p[0] + p[1] ==  c ){ printf( '%d %d\n' , p[0] , p[1] ) } 
}
\end{lstlisting}
Obviously, the block of the break is optional.
\end{subsection}

\begin{subsection}{Substitute for Select}
\index{Flow Control : usage of continue}
One can readily use the $break$ and $continue$ in larger scheme of comprehensions.
Observe this :

\begin{lstlisting}[style=zmbStyle]
l_e1 = select([0:10]) :: { $.o % 2 == 0 }
l_e2 = list([0:10]) -> { continue($.o % 2 != 0) ; $.o }
\end{lstlisting}
Both are the same list. Thus, a theoretical conversion rule is :

\begin{lstlisting}[style=zmbStyle]
ls = select(collection) where { <condition> }
lc = list(collection) as { continue( ! ( <condition> ) ) ; $.o }
\end{lstlisting}
now, the $ls == lc$, by definition.
More precisely, for a generic $select$ with $where$ clause:

\begin{lstlisting}[style=zmbStyle]
ls = select(collection) where {  <condition body>  }
lc = list(collection) as { continue( !(<condition>) ) ; <body> }
\end{lstlisting}
Obviously, the $list$ function can be replaced with any $collection$ type : $set, dict$.

Similarly, $break$ can be used to simplify conditions :

\begin{lstlisting}[style=zmbStyle]
l_e1 = select([0:10]) :: { $.o % 2 == 0 && $.o < 5 }
l_e2 = list([0:10]) -> { break( $.o > 5 ) ; 
       continue($.o % 2 != 0) ; $.o }
\end{lstlisting}

Note that Break body is inclusive:
  
\begin{lstlisting}[style=zmbStyle]
l = list([0:10]) as { break( $.o > 3 ) ; $.o }
/* l = [ 0, 1,2,3 ] */
l = list([0:10]) as { break( $.o > 3 ) { $.o } ; $.o }
/* l = [ 0, 1,2,3, 4] */

\end{lstlisting}
 
So, with a body, the  value from the body  is included into the collection.
\end{subsection}

\begin{subsection}{Uses of Partial}
One can use the \emph{PARTIAL} for using one one function to substitute another,
albeit loosing efficiency.
Below, we use list to create \emph{effectively} a set:

\begin{lstlisting}[style=zmbStyle]
l = list( 1,1,2,3,1,3,4 ) as { continue( $.o @ $.p ) ; $.o }
/* l = [ 1,2,3, 4] */
\end{lstlisting}

But it gets used properly in more interesting of cases.
What about finding the prime numbers using the \href{https://en.wikipedia.org/wiki/Sieve_of_Eratosthenes}{Sieve of Eratosthenes}?
We all know the drill imperatively:
\index{Sieve of Eratosthenes : imperativel}

\begin{lstlisting}[style=zmbStyle]
def is_prime( n ){
    primes = set(2,3,5)
    for ( x : [6:n+1] ){
        x_is_prime = true 
        for ( p : primes ) {
            break( x % p == 0  ){ x_is_prime = false }
        }
        if ( x_is_prime ){
          if ( x == n ) return true 
          primes += x 
        }
    }
    return false 
}
\end{lstlisting}
Now, a declarative style coding :
\index{Sieve of Eratosthenes : declarative}
\begin{lstlisting}[style=zmbStyle]
def is_prime( n ){
    primes = list( [2:n+1] ) as {
    // store the current number
        me = $.o
        // check : *me* is not prime - using partial set of primes
        not_prime_me = exists( $.p ) where {  me % $.o == 0 }
        // if not a prime, continue 
        continue( not_prime_me )
        me // collect me, if I am prime  
    }
    // simply check if n is last of the primes
    ( n == primes[-1] )  
}
\end{lstlisting}
Observe that, if we remove the comments, it is a one liner. 
It really is. Hence, declarative style is indeed succinct, and very powerful.
The one reason why we need to create the $me$ variable is due to the implicit parameter $\$$.
The implicit loop variable also as a field $\$$ which access the parent's loop parameter.
Thus, the same code can be written in a line :

\begin{lstlisting}[style=zmbStyle]
n == (select([2:n+1]) where{ exists($.p) where{ $.o /? $.$.o } })[-1] 
\end{lstlisting}

\end{subsection}

\end{section}



\begin{section}{Comprehensions using Multiple Collections : Join}
\index{Multiple Collection Comprehension : join()}

In the previous sections we talked about the comprehensions using a single collection.
But we know that there is this most general purpose comprehension, that is, 
using multiple collections. This section we introduce the $join()$ function.

\begin{subsection}{Formalism}
Suppose we have multiple sets $S_1,S_2,...S_n$.
Now, we want to generate this collection of tuples 
$$
e = <e_1,e_2,...,e_n> \; \in S_1 \times S_2 \times ... \times S_n
$$ 
such that the condition ( \href{https://en.wikipedia.org/wiki/Predicate\_(mathematical\_logic)}{predicate} ) $P(e) = true $. \index{predicate}
This is what join really means. Formally, then :
$$
J(P,e) := \{  e \in S_1 \times S_2 \times ... \times S_n \; | \; P(e) \} 
$$

\end{subsection}

\begin{subsection}{As Nested Loops}
Observe this, to generate a cross product of collection $A,B$, we must
go for nested loops like this:

\begin{lstlisting}[style=zmbStyle]
for ( a : A ){
   for ( b : B ) {
     printf ( '(%s,%s)', a,b ) 
   }
}
\end{lstlisting}
This is generalised for a cross product of $A,B,C$, and generally into any cross product. 
Hence, the idea behind generating a tuple is nested loop.

Thus, the $join()$ operation with $condition()$ predicate with a $mapper()$ essentially is :

\begin{lstlisting}[style=zmbStyle]
collect = collection()
for ( a : A ){
   for ( b : B ) {
      tuple = [a,b]
      if ( condition ( tuple ) ) { collect += map(tuple) } 
   }
}
\end{lstlisting}
\end{subsection}

\begin{subsection}{Join Function}
\index{join()}
Observe that the free join, that is a join without any predicate, 
or rather join with predicate defaults to true is really a full cross product, 
and is available using the power operator :

\begin{lstlisting}[style=zmbStyle]
A = ['a','b']
B = [ 0, 1 ]
j1 = A * B // [ [a,0] , [a,1] ,[b,0], [b,1] ]
j2 = join( A , B ) // [ [a,0] , [a,1] ,[b,0], [b,1] ]
\end{lstlisting}

But the power of $join()$ comes from the predicate expression one can pass in 
the anonymous block. Observe now, if we need 2 permutations of a list of 3 : $^3P_2$ :

\begin{lstlisting}[style=zmbStyle]
A = ['a','b', 'c' ]
// generate 2 permutations, when $.o is collection
// one can access the items by index like this 
p2 = join( A , A ) where { $.0 != $.1 }  
\end{lstlisting}
 
\end{subsection}

\begin{subsection}{Permutations }
\index{Permutations, perm()}

In the last subsection we figured out how to find 2 permutation.
The problem is when we move beyond 2, the condition can not be aptly specified as $\$.0 \ne \$.1 $.
It has to move beyond. So, for $^3P_3$ we have :

\begin{lstlisting}[style=zmbStyle]
A = ['a','b', 'c' ]
// generate 3 permutations 
p2 = join( A , A,  A ) where { #|set($.o)| == #|$.o| }  
\end{lstlisting}

which is the declarative form for permutation, given all elements are unique. This can be simply created by the 
pre-defined \emph{perm()} function :

\begin{lstlisting}[style=zmbStyle]
A = ['a','b', 'c' ]
// generate 3 permutations 
p2 = perm( A, 2  ) //  From collection A, generate 2 permutations 
// @[ a,b ],@[ b,a ],@[ a,c ],@[ c,a ],@[ b,c ],@[ c,b ] // CombinatoricsIterable
// hence, 
perm(collection, number) // generates an iterable 
\end{lstlisting}


\end{subsection}


\begin{subsection}{Combinations }
\index{Combinations, comb()}

What about combinations then? Difference between permutation and combination is, 
in combination, order does not matter, hence $(1,2)$ is same combination as $(2,1)$, while
they are two distinct permutations. 

\begin{lstlisting}[style=zmbStyle]
A = ['a', 'b', 'c' ]
c2 = join( A, A ) where {
    c = sorta( list($.o) )
    c !@ $.p &&  #|set(c)| == #|c| 
}
\end{lstlisting}

which is the declarative form for combination, given all elements are unique. This can be simply created by the 
pre-defined \emph{comb()} function :

\begin{lstlisting}[style=zmbStyle]
A = ['a','b', 'c' ]
// generate 3 combinations 
c2 = comb( A, 2  ) //  From collection A, generate 2 combinations 
@[ a,b ],@[ a,c ],@[ b,c ] // CombinatoricsIterable
comb(collection, number) // generates an iterable 
\end{lstlisting}


\end{subsection}


\begin{subsection}{Searching for a Tuple }
\index{Searching for a tuple}

In the last section we were searching for a tuple $t$ from two collections $A,B$,
such that $c = t.0 + t.1$. We did that using power and break, now 
we can do slightly better:

\begin{lstlisting}[style=zmbStyle]
A = [ 1, 4, 10, 3, 8 ] 
B = [ 2, 11, 6 , 9 ]
c = 10
v = join(A,B) :: { break( $.0 + $.1 == c) } 
/* v := [[1,9]] */
\end{lstlisting}

which is the declarative form of the problem. 
\end{subsection}


\begin{subsection}{SQL Style Optimization}
\index{SQL Optimization}
\index{hashed join}

Imagine someone trying to do this:

\begin{lstlisting}[style=zmbStyle]
l1 = list ( [0:1000] ) as { { "id" : random(10000000) , "x" : random(100) } }
l2 = list ( [0:1000] ) as { { "id" : random(10000000) , "y" : random(100) } }
#( t, o ) = #clock{
  // now do join over something
  g1 = mset( l1 ) as { $.id }
  g2 = mset( l2 ) as { $.id }
  g1 * g2  // would not work - but hypothetical code here 
  }
\end{lstlisting}
Essentially this is joining with an attribute 'id'.
This can be done with a massive complexity of $\Theta(MN)$ as follows:

\begin{lstlisting}[style=zmbStyle]
join( l1, l2 ) where { $.l.id == $.r.id } as { $.l | $.r }
\end{lstlisting}

This pose a problem. Hence we do have a sql optimised join which relies on keys:


\begin{lstlisting}[style=zmbStyle]
a = list ( [0:300] ) as {  { "id" : $.i + 1 ,  "a" : random(500) } }
b = list ( [0:300] ) as {  { "id" : $.i + 1 ,  "b" : random(500) } }
c = list ( [0:300] ) as {  { "id" : $.i + 1 ,  "c" : random(500) } }

r = join( a, b, c ) as {  $.o.id } where { 
   $.0.a > 100 && $.1.b < 100 && $.2.c > 200  
 } as {  ($.0 | $.1 | $.2) 
\end{lstlisting}

Notice the first \emph{as} block. Ordering matters. First as block is the key to be used for a \emph{hashed join}.
This takes care of the problem of complexity.
\end{subsection}



\begin{subsection}{All Possible Sub Collections}
Suppose, given a collection $C$, we want to find out all possible sub collection inside that collection. This tantamount to 
what is known as Power Set or $ 2^C $. One way to solve this problem is to imagine that each sub collection from 
the original collection is created by a bitmap with 1 means select that index, and 0 means do not select the index.
If the $|C| = n $, then clearly $2^n$ of those sub collections possible. This can be coded as in:

\begin{lstlisting}[style=zmbStyle]
def all_sub_collection( col ){
  power_col = list()
  n = size(col)
  for ( b : [0 : 2 ** n ] ){
    bit_map = str(b,2) // binary rep of integer b 
    bit_map = '0' ** ( n - size( bit_map) ) + bit_map
    sub_col = list()
    for ( i : [0:n] ){
        if ( bit_map[i] == _'1' ){
            sub_col += col[i]
        }
    }
    power_col.add( sub_col )
  }
  println( power_col )
}
\end{lstlisting}
\index{ Power Collection : powerset() }
This is too much of non declarative hodge-podge. This can be simply coded in as :
\begin{lstlisting}[style=zmbStyle]
a =[0, 1, 2]
// generates all possible combination sequences possible using collection
for ( t : powerset(a) ) { println(t) } 
\end{lstlisting}


\end{subsection}

\begin{subsection}{Projection on Collections}
\index{project}

Sometimes it is needed to create a sub-collection from the collection. 
This, is known as projection ( choosing specific columns of a row vector ).

While project works on a range \emph{(from,to)}, the generic idea can be expanded. 
What if we  want to create a newer collection from a collection using a $range$ type? 
We can : \index{collection : slicing }

\begin{lstlisting}[style=zmbStyle]
a =[0, 1, 2, 3, 4]
a[0:2] // @[0, 1, 2]
\end{lstlisting}

Now, given a set of indices, one can define a generic project operation, 
but that is very easy to do using collection comprehensions :

\begin{lstlisting}[style=zmbStyle]
a = [0, 1, 2, 3, 4]
indices = [0,2]
p_a = list(indices) as { continue( $.i != $.o ) ; a[$.o] }  
\end{lstlisting}
This simply selects those indices in order from the collection $a$.
In fact, defining \emph{project()} or \emph{tuple()} is easy :

\begin{lstlisting}[style=zmbStyle]
a = [0, 1, 2, 3, 4]
indices = [from_index,to_index]
p_a = select(a) where {  $.i >= indices.0 && $.i < indices.1 ) }  
\end{lstlisting}

\end{subsection}

\end{section}

